'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function isPromise(obj) {
  return !!obj && (typeof obj === 'object' || typeof obj === 'function') && typeof obj.then === 'function' && typeof obj['catch'] === 'function';
}

var notify = function notify(events, config) {
  return function (_ref) {
    var dispatch = _ref.dispatch;
    return function (next) {
      return function (action) {
        var promiseChain = undefined;

        events.forEach(function (event) {
          if (event['catch'].indexOf(action.type) !== -1) {
            if (config && config.noReverse) {
              if (action.notified) return;else action = _extends({}, action, { notified: true });
            }
            if (event.dispatch instanceof Function) {
              setTimeout(function () {
                dispatch(event.dispatch(action));
              }, 0);
            } else if (event.dispatch instanceof Array) {
              event.dispatch.forEach(function (fn) {
                setTimeout(function () {
                  if (isPromise(promiseChain)) {
                    promiseChain = promiseChain.then(function () {
                      return dispatch(fn(action));
                    })['catch'](function (e) {
                      throw new Error(e);
                    });
                  } else {
                    var res = dispatch(fn(action));
                    if (isPromise(res)) {
                      promiseChain = res;
                    }
                  }
                }, 0);
              });
            } else throw new Error('Expected dispatch value to be a function or an array of functions.');
          }
        });
        return next(action);
      };
    };
  };
};

exports['default'] = notify;
module.exports = exports['default'];